# -*- coding: utf-8 -*-

#change the default directory
import os
os.chdir("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/gradient boosting")

#import the dataset
import pandas
dtrain = pandas.read_table("opt_digits_train.txt",sep="\t",header=0,decimal=".")
print(dtrain.shape)

#target attribute - training set
y_app = dtrain.as_matrix()[:,0]

#descriptors - train set
X_app = dtrain.as_matrix()[:,1:64]

#import the test set
dtest = pandas.read_table("opt_digits_test.txt",sep="\t",header=0,decimal=".")
print(dtest.shape)

#convert into matrix
y_test = dtest.as_matrix()[:,0]
X_test = dtest.as_matrix()[:,1:64]


#object for the gradient boosting
from sklearn.ensemble import GradientBoostingClassifier
gb = GradientBoostingClassifier()

#print settings of the approach
print(gb)

#training process
gb.fit(X_app,y_app)

#prediction
y_pred = gb.predict(X_test)

#evaluation : test error rate
from sklearn import metrics
err = 1.0 - metrics.accuracy_score(y_test,y_pred)
print(err)

#research grid for settings
from sklearn.grid_search import GridSearchCV

#parameters to try
parametres = {"learning_rate":[0.3,0.2,0.1,0.05,0.01],"max_depth":[2,3,4,5,6],"subsample":[1.0,0.8,0.5],"max_features":[None,'sqrt','log2']}

#learning classifier to use
gbc = GradientBoostingClassifier()

#object for the search
grille = GridSearchCV(estimator=gbc,param_grid=parametres,scoring="accuracy") 

#search process
resultats = grille.fit(X_app,y_app)

#all performances
print(resultats.grid_scores_)

#best performances
print(resultats.best_score_)

#best parameters
print(resultats.best_params_)

#prediction with the best parameters
ypredc = resultats.predict(X_test)

#test error rate
err_best = 1.0 - metrics.accuracy_score(y_test,ypredc)
print(err_best)

#random forest
from sklearn.ensemble import RandomForestClassifier

#object RandomForest
rf = RandomForestClassifier(n_estimators = 100)

#learning process
rf.fit(X_app,y_app)

#prediction
y_pred_rf = rf.predict(X_test)

#test error rate
err = 1.0 - metrics.accuracy_score(y_test,y_pred_rf)
print(err)
